(
        prime.f

        A few routines for dealing with primes. Also features the
        worst definition of ln[x] ever!
)

dict prime
use prime

create list 36 cells allot

: bits ( a -- b )                       ( Number of bits used in a )
  0 swap begin
    dup 0= if  drop  ;then              ( While a isn't 0: )
    2/  swap 1+ swap                    ( Shift right and increase counter )
  again ;
: guess  ( n -- x )
  bits 2/ 1 swap << ;                   ( 2^[1/2 * log2 n] )
: step  ( n x -- x )
  dup>r / r> + 2/ ;                     ( x2 = [n/x1 + x1] / 2 )
: close?  ( x1 x2 -- a )
  - 1+ 3 < ;                            ( Within +/- 1? )
: (sqrt)  ( n x1 -- x2 a )
  dup>r step dup r> close? ;            ( Iterate, check if close enough )
: sqrt ( n -- x )
  dup guess  begin
    over >r (sqrt) if
      r> drop
    ;then
    r> swap
  again ;

: even?  1 and 0= ;
: prime? ( n -- a )
  dup even? if  drop false  ;then       ( Return false if even )
  dup 3 = if  drop true  ;then          ( Need to give 3 explicitly )
  dup sqrt 2/ 3 swap for                ( sqrt(n)/2 times: )
    2dup mod 0= if                      ( Return false if n mod k = 0 )
      2drop false break;
    then
  2+ next  2drop true ;                 ( No divisors found? Return true )

: primes ( -- )
  3 list 80 for                         ( Search until 2^8+1 )
    over prime? if                      ( If prime: )
      2dup !                            ( Store in list )
      cell+                             ( And go to next item )
    then
  swap 2+ swap                          ( Try next odd number )
  next 2drop ;

primes                                  ( Generate prime list )

: prime? ( n -- a )
  dup even? if  drop false  ;then       ( Return false if even )
  dup sqrt >r                           ( Calculate sqrt[n] and store )
  list begin
    2dup @ dup r> dup>r > if            ( Is prime > sqrt[n]? )
      2drop 2drop true break;
    then
    mod 0= if                           ( If this prime divides n: )
      2drop false break;                ( Return false )
    then
  cell+ again ;

: pi ( n -- a )
  dup 2 < if  drop 0  ;then
  dup 3 < if  drop 1  ;then
  dup 5 < if  drop 2  ;then             ( Elementary cases )
  2 swap 3 swap                         ( pi[n] and the counter )
  3 - 2/ for                            ( Only check odd numbers )
    dup prime? if                       ( If prime, increase pi[n] )
      swap 1+ swap
    then
  2+ next drop ;

: ln ( n -- a )
  dup pi / 1+ ;

leave prime

