(
        debug.f

        Words mainly used for debugging, or simply playing
        around in the interactive environment

        How to use catch/throw:

123 var some-var
: screw 4 5 6 throw ;
: thing-that-can-go-wrong  some-var = if  1 2 3 screw  then drop ;
: x  123 catch thing-that-can-go-wrong  drop ." Murphy was right" cr ;
This should print "Myprhy was right" if some-var is equal to 123, or do
nothing in case it isn't. Note that x will return immediately in case NO
exception occurs. If an exception does occur, execution will continue isnide
x. The data stack will be restored to what it was BEFORE the call to
thing-that-can-go-wrong, which means YOU must take care of whatever's on
there. In case you need to know WHAT went wrong, just use a var.

)

: body>header ( a -- b ) cell- @ ;
: header>name ( a -- b ) 5 + ;
: .word ( a -- )  header>name 10 print-fill ;
: .wordlist ( a -- )
  begin
    ?dup
  while
    dup .word @
  ;while ;
: words ( -- )  cr last .wordlist cr ;
: depth ( -- n )  sp0 sp - 2/ 1- ;
: s.  sp0 2- 2- depth 1-
  ?dup if
    for  dup @ . space  2-  next drop
  ;then  drop ." Empty " ;
: check  sp sp0 > if cr ." Stack underflow" cr sp0 sp! ;then ;
: hex     10 -> base ;
: decimal a -> base ;
: octal   8 -> base ;
: binary  2 -> base ;
: \  begin input dup d = swap a = or until ; immediate

: (-check ( a -- b )
  dup [char] ( = if  drop 1+  ;then
      [char] ) = if       1-  ;then ;
: (  1 begin  input (-check  ?dup repeat ; immediate

: threaded? ( a -- true|false )  1+ dup @ swap 2+ ['] nest swap - = ;
: word? ( a -- true|false )  dup 2- @ 2+ @ = ;
: print-word ( a -- )  body>header header>name print ;
: see-word ( a -- )  dup word? if print-word space ;then . space ;
: (see) ( a n -- )  3+ swap for  dup @ see-word cell+  next drop cr ;
: see ( n -- )  ' ?dup 0= if ;then  (see) ;

create tstack 10 allot
tstack 10 + var tptr
: tdup ( -- )  tptr 2- -> tptr ;
: tpush ( a -- )  tdup  tptr ! ;
: tdrop ( -- )  tptr 2+ -> tptr ;
: tpop  ( -- a ) tptr @  tdrop ;
: catch  [compile] sp [compile] tpush
         [compile] rp [compile] 2- [compile] tpush
         ' , [compile] tdrop [compile] tdrop [compile] exit ; immediate
: throw  tpop  6 over +!  rp!  tpop sp! ;
