; fload.asm
;
; fload and similar words.

; fpush ( file -- )
; fdrop ( -- )
; fload-file ( a -- )
; fload ( -- )

; fpush ( file -- )
header code_fpush,"fpush",flag_none
code_fpush:
        sub     word[fptr],2            ; fptr -= 2.
        mov     di,[fptr]               ; di = fptr.
        mov     [di],bx                 ; [fptr] = TOS.
        pop     bx                      ; Pop new TOS.
        next

; fdrop ( -- )
header code_fdrop,"fdrop",flag_none
code_fdrop:
        push    bx
        mov     di,[fptr]               ; di = fptr
        mov     bx,[di]                 ; bx = top of file stack.
        add     word[fptr],2
        mov     ah,0x3e                 ; Close file.
        int     0x21
        pop     bx
        next

; fload-file ( a -- )
header code_fload_file,"fload-file",flag_none
code_fload_file:
        call    nest
        dw      code_do_branch,code_fload.load

; fload ( -- )
header code_fload,"fload",flag_none
code_fload:
        call    nest
        dw      code_read,code_word     ; read word
        dw      code_toasciiz           ; >asciiz
        dw      code_word               ; word
.load:  dw      code_do_lit,0           ; 0      (read-only mode)
        dw      code_fopen              ; fopen
        dw      code_cdup               ; ?dup
        dw      code_do_cbranch,.ok     ; if TOS <> 0, goto .ok
        dw      code_do_lit,.msg_err    ; .msg_err
        dw      code_print              ; print
        dw      code_exit               ; exit
.ok:    dw      code_fpush              ; fpush
        dw      code_exit               ; exit
.msg_err:
        db      0x15,0x0d,0x0a,"Can not open file",0x0d,0x0a
